variables:
  CI_DEBUG_TRACE: 
    value: ''
    description: "Verbose output of all of GitLab's output, including git cloning information. More info: https://docs.gitlab.com/ee/ci/variables/#enable-debug-logging"
  JOB_TRACE: 
    value: 'false'
    description: "Verbose output of CI job scripts." #can use in all jobs for universal tracability.
  SOMEUTILITY_TRACE: 
    value: 'false'
    description: "someutility.sh will have debug output enabled." #Only use if job contains utilities that you would like to switch their debug output on.
  SECURE_LOG_LEVEL: 
    value: ''
    description: "Set to one of: 'fatal,warn,error,info,debug' More info: https://docs.gitlab.com/ee/user/application_security/sast/#logging-level"
  TRACE: 
    value: ''
    description: "Set to 1 to output helm verbose output. More Info: https://docs.gitlab.com/ee/topics/autodevops/customize.html#cicd-variables" 
  AUTO_DEVOPS_DEPLOY_DEBUG:
    value: ''
    description: "Set to anything to output helm debug logs. More Info: https://docs.gitlab.com/ee/topics/autodevops/customize.html#cicd-variables"

  #These variables help tracing git operations that are done by GitLab automatically and any manual git commands you have embedded.
  #More information including more tracing variables: https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  GIT_SSH_COMMAND:
    value: ''
    description: "Set to exactly 'ssh -vvv' to trace SSH based cloning. By default the runner clones are https - this variable is most useful if you have custom ssh clones in your code. More info: https://docs.gitlab.com/ee/topics/git/useful_git_commands.html#debugging-with-git-embedded-traces"
  GIT_CURL_VERBOSE:
    value: ''
    description: 'Set to 1 to enable tracing of git https operations. More info: https://docs.gitlab.com/ee/topics/git/useful_git_commands.html#debugging-with-git-embedded-traces'
  GIT_TRACE_PERFORMANCE:
    value: ''
    description: 'Set to 1 to enable tracing of performance data, showing how long each particular git invocation takes More info: https://docs.gitlab.com/ee/topics/git/useful_git_commands.html#debugging-with-git-embedded-traces'
  GIT_TRACE_PACKET:
    value: ''
    description: 'Set to 1 to enable tracing packet-level tracing for network operations. More info: https://docs.gitlab.com/ee/topics/git/useful_git_commands.html#debugging-with-git-embedded-traces'    
  GIT_TRACE_SETUP:
    value: ''
    description: 'Set to 1 to enable tracing of what git is discovering about the repository and environment it’s interacting with. More info: https://docs.gitlab.com/ee/topics/git/useful_git_commands.html#debugging-with-git-embedded-traces'


default:
  after_script:
    - |
      echo "A great way to understand state and file changes after every job (if you don't depend on after_script already)"
      echo "list files"
      ls -ashl
      echo "variables"
      env -0 | sort -z | tr '\0' '\n'
  before_script:
  - |
      #Checking for CI_DEBUG_TRACE makes our debug code also respond to that parametera
      if [[ "${JOB_TRACE}" == "true" ]] || [[ -n "${CI_DEBUG_TRACE}" ]]; then
        echo "Debugging of CI scripts is enabled"
        echo "  * Verbose shell processing enabled with 'set -x'"
        set -v
      fi    

test:
  script:
    - |
      echo "This is the regular job code processing."

      #Checking for CI_DEBUG_TRACE makes our debug code also respond to that parametera
      if [[ "${SOMEUTILITY_TRACE}" == "true" ]] || [[ -n "${CI_DEBUG_TRACE}" ]]; then
        echo "Tracing is on, showing Gitversion configuration (including settings from defaults)..."
        SOMEUTILITYSWITCHES='--debug'
      fi

      chmod +x someutility.sh
      ./someutility.sh ${SOMEUTILITYSWITCHES}

      echo "More regular job stuff processing."


